;-------------------------------------------------------------------------
;-------------------------------------------------------------------------
.386p
CSEG segment use16
assume cs:cseg, ds:cseg, ss:cseg, es:cseg
	org	100h
start:
;-------------------------------------------------------------------------
DESCRIPTOR struc
	limit_low		dw	?	; low word segment limit
	address_low		dw	?	; low word segment address
	address_hi		db	?	; third byte segment address
	access_rights		db	?	; rights
	limit_hi_and_flags	db	?	; high part of limit and GDXU flag
	address_high		db	?	; fourth byte segment address
DESCRIPTOR ends
;-------------------------------------------------------------------------
Code_selector		equ	 8	; selector
Data_selector		equ	16	; Index 13 bit
R_Mode_Code		equ	24	; RPL - Requested Privilege Level 2 bit
R_Mode_Data		equ	32	; 00-Ring0....
Stack_selector		equ	40	; TI 0- Global DT, 1- Local DT 1 bit
Screen_selector		equ	48	; [----INDEX---- TI RPL]
;--------------------------------------------------------------------------
	mov	R_Mode_SS,ss		; save R-Mode segment registers
	mov	R_Mode_DS,ds		;
	mov	R_Mode_ES,es		;
	mov	R_Mode_FS,fs		;
	mov	R_Mode_GS,gs		;

	mov	R_Mode_segment,cs	; back to real address
	;lea	ax,R_Mode_entry		;
	;mov	R_Mode_offset,ax	;

	xor	eax, eax		;
	mov	ax, cs			;
	shl	eax,4			; 32 bit segment address

	xor	edx, edx		; GDTR register
	lea	dx,GDT			; 
	add	edx, eax		;
	mov	GDT_adr,edx		; 

	lea	bx, descriptor_code	; create GDT
	call	set_descriptor
	lea	bx, descriptor_code_R_Mode
	call	set_descriptor
	lea	bx, descriptor_stack_and_data_R_Mode
	call	set_descriptor
	lea	bx, descriptor_data
	call	set_descriptor

	add	eax,0ffffh
	lea	bx, descriptor_stack
	call	set_descriptor

	cli				; 
	lgdt	GDTR			; GDTR

	mov	R_Mode_SP,sp		; save R-Mode segment registers

	mov	eax,cr0			; Protected Mode
	or	al,1			; 
	mov	cr0,eax			; 

	db	0eah			; far jmp 
	dw	P_Mode_entry		; 
	dw	Code_selector
;--------------------------------------------------------------------------
P_Mode_entry:
	mov	ax,Screen_selector
	mov	es,ax
	mov	ax,Data_selector
	mov	ds,ax
	mov	ax,Stack_selector
	mov	ss,ax
	mov	sp,0

	lea	si,Start_P_Mode_ZS
	mov	di,520
	call	putzs

	lea	si,P_Mode_ZS
	mov	di,680
	call	putzs

;--------------------------------------------------------------------------
	;cli

	db	0eah		; far jmp R_Mode_Code:Pre_R_Mode_entry.
	dw	Pre_R_Mode_entry
	dw	R_Mode_Code

Pre_R_Mode_entry:
	mov	ax,R_Mode_Data	; 
	mov	ss,ax
	mov	ds,ax
	mov	es,ax
	mov	fs,ax
	mov	gs,ax

	mov	eax,cr0
	and	al,0feh		; 
	mov	cr0,eax

		db	0eah	; far jmp 
R_Mode_offset	dw	R_Mode_entry	; 
R_Mode_segment	dw	?	; 
				; 
;------------------------------------------------------------------------
R_Mode_entry	label		word

	mov	ss,R_Mode_SS	; 
	mov	ds,R_Mode_DS	; 
	mov	es,R_Mode_ES	; 
	mov	fs,R_Mode_FS	; 
	mov	gs,R_Mode_GS	; 
	mov	sp,R_Mode_SP	; 

	sti

	lea	si,R_Mode_ZS
	mov	ax,0b800h
	mov	es,ax
	mov	di,840
	call	putzs		; 

	int	20h		; exit

;-------------------------------------------------------------------------
set_descriptor	proc	near
	mov	ecx, eax
	and	ecx, 11111111000000000000000000000000b	; fourth byte segment address
	or	ecx, dword ptr[bx+4]
	mov	dword ptr[bx+4], ecx
	mov	ecx, eax
	and	ecx, 111111111111111111111111b	; first three bytes segment address
	or	ecx, dword ptr[bx+2]
	mov	dword ptr[bx+2], ecx
	ret
set_descriptor	endp
;-------------------------------------------------------------------------
putzs	proc	near		; zero string to video memory
	mov	ah,1bh		; color attributes
putzs_1:
	lodsb
	cmp	al,0		; 
	je	putzs_end	; 
	stosw
	jmp	putzs_1		; 
putzs_end:
	ret
putzs		endp
;--------------------------------------------------------------------------
Start_P_Mode_ZS		db	"Entering to protected mode...",0
P_Mode_ZS		db	"Working in P-mode...         ",0
R_Mode_ZS		db	"Back to real address mode... ",0

R_Mode_SP		dw	?
R_Mode_SS		dw	?
R_Mode_DS		dw	?
R_Mode_ES		dw	?
R_Mode_FS		dw	?
R_Mode_GS		dw	?
;--------------------------------------------------------------------------
;   GDTR:

GDTR	label		fword
GDT_lim			dw	55
GDT_adr			dd	?
;--------------------------------------------------------------------------
align 16				;       ---limit low word----address 3 bytes-----rights---high 4bit limit&GDXU-address 4-s byte
GDT:
descriptor_zero				DESCRIPTOR <	00000h,		0,	0,		0,	0000b,		0>
descriptor_code				DESCRIPTOR <	003ffh,		0,	0,	10011000b,	0000b,		0>
descriptor_data				DESCRIPTOR <	0ffffh,		0,	0,	10010010b,	0000b,		0>
descriptor_code_R_Mode			DESCRIPTOR <	0ffffh,		0,	0,	10011010b,	0000b,		0>
descriptor_stack_and_data_R_Mode	DESCRIPTOR <	0ffffh,		0,	0,	10010010b,	0000b,		0>
descriptor_stack			DESCRIPTOR <	003ffh,		0,	0,	10010110b,	0000b,		0>
descriptor_screen			DESCRIPTOR <	0ffffh,		8000h,	0bh,	10010010b,	0000b,		0>
;--------------------------------------------------------------------------
;--------------------------------------------------------------------------
	CSEG	ends
	end	start
;--------------------------------------------------------------------------